//+------------------------------------------------------------------+
//|                                                  Guppy delta.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "brax64 - forexTSD"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Crimson
#property indicator_color2 MediumSeaGreen
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 DarkGreen
#property indicator_color6 Maroon
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 2
#property indicator_width6 2

extern bool   show_Histo       = true;
extern string _                = "Arrows settings:";
extern bool   arrowsVisible    = true;
extern string arrowsIdentifier = "GuppyArrows";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Red;
extern string __               = "Alerts settings:";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;


double gmmadelta[];
double gmmaplus[];
double gmmaminus[];
double gmmaplusM[];
double gmmaminusP[];
double gmmashort[];
double gmmalong[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,gmmashort);  SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"short");
   SetIndexBuffer(1,gmmalong);   SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"long");
   SetIndexBuffer(2,gmmaplus);   SetIndexStyle(2,DRAW_NONE); SetIndexLabel(2,NULL);
   SetIndexBuffer(3,gmmaminus);  SetIndexStyle(3,DRAW_NONE); SetIndexLabel(3,NULL);
   SetIndexBuffer(4,gmmaplusM);  SetIndexStyle(4,DRAW_NONE); SetIndexLabel(4,NULL);
   SetIndexBuffer(5,gmmaminusP); SetIndexStyle(5,DRAW_NONE); SetIndexLabel(5,NULL);   
   SetIndexBuffer(6,gmmadelta);  SetIndexStyle(6,DRAW_NONE); SetIndexLabel(6,NULL);
   SetIndexBuffer(7,trend);      SetIndexStyle(7,DRAW_NONE); SetIndexLabel(7,NULL);

   if(show_Histo)
   {
      SetIndexStyle(0,DRAW_NONE);      SetIndexLabel(0,NULL);
      SetIndexStyle(1,DRAW_NONE);      SetIndexLabel(1,NULL);   
      SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"delta ++");
      SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"delta --");
      SetIndexStyle(4,DRAW_HISTOGRAM); SetIndexLabel(4,"delta +-");
      SetIndexStyle(5,DRAW_HISTOGRAM); SetIndexLabel(5,"delta -+");
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
{
   string lookFor       = arrowsIdentifier + ":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string objectName = ObjectName(i);
         if(StringSubstr(objectName, 0, lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i, limit, counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;

   for(i = limit; i >= 0; i--)
   {
      gmmashort[i] = iMA(NULL, 0,  3, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0,  5, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0,  8, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 12, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 15, 0, MODE_EMA, PRICE_CLOSE, i);
      
      gmmalong[i]  = iMA(NULL, 0, 30, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 35, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 40, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 45, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 50, 0, MODE_EMA, PRICE_CLOSE, i)+
                     iMA(NULL, 0, 60, 0, MODE_EMA, PRICE_CLOSE, i);

      gmmadelta[i] = (gmmashort[i] - gmmalong[i]) * 1000;
      
      trend[i] = trend[i+1];
      if(gmmadelta[i] > 0 && gmmadelta[i+1] < 0) trend[i] =  1;
      if(gmmadelta[i] < 0 && gmmadelta[i+1] > 0) trend[i] = -1;      
      
      if(show_Histo)
      {
         gmmaplus[i]   = EMPTY_VALUE;
         gmmaminus[i]  = EMPTY_VALUE;
         gmmaplusM[i]  = EMPTY_VALUE;
         gmmaminusP[i] = EMPTY_VALUE;
         
         if(gmmadelta[i] > 0 && gmmadelta[i] >= gmmadelta[i+1]) gmmaplus[i]   = gmmadelta[i];
         if(gmmadelta[i] > 0 && gmmadelta[i] <  gmmadelta[i+1]) gmmaplusM[i]  = gmmadelta[i];
         if(gmmadelta[i] < 0 && gmmadelta[i] <  gmmadelta[i+1]) gmmaminus[i]  = gmmadelta[i];
         if(gmmadelta[i] < 0 && gmmadelta[i] >= gmmadelta[i+1]) gmmaminusP[i] = gmmadelta[i];
      }
      manageArrows(i);
   }
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageArrows(int i)
{
   if(arrowsVisible)
   {
      deleteArrows(Time[i]);
      if(trend[i] != trend[i+1])
      {
         if(trend[i] ==  1) drawArrows(i, arrowsUpColor, 241);
         if(trend[i] == -1) drawArrows(i, arrowsDnColor, 242);
      }
   }
}               

void drawArrows(int i,color theColor,int theCode)
{
   string name = arrowsIdentifier + ":" + Time[i];
   double gap  = 3 * iATR(NULL, 0, 20, i) / 4;   
      
   ObjectCreate(name, OBJ_ARROW, 0, Time[i], 0);
      ObjectSet(name, OBJPROP_ARROWCODE, theCode);
      ObjectSet(name, OBJPROP_COLOR, theColor);
      if(trend[i] ==  1)
            ObjectSet(name, OBJPROP_PRICE1, Low[i]  - gap);
      else  ObjectSet(name, OBJPROP_PRICE1, High[i] + gap);
}

void deleteArrows(datetime time)
{
   string lookFor = arrowsIdentifier + ":" + time;
   ObjectDelete(lookFor);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageAlerts()
{
   if(alertsOn)
   {
      if(alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if(trend[whichBar] ==  1) doAlert(whichBar, "up");
         if(trend[whichBar] == -1) doAlert(whichBar, "down");
      }
   }
}

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert = "nothing";
   static datetime previousTime;
   string message;
   
   if(previousAlert != doWhat || previousTime != Time[forBar])
   {
      previousAlert  = doWhat;
      previousTime   = Time[forBar];

      message = Symbol() + " at " + TimeToStr(TimeLocal(),TIME_SECONDS) + " Guppy delta trend changed to " + doWhat;
          if(alertsMessage) Alert(message);
          if(alertsEmail)   SendMail(Symbol() + "Guppy delta", message);
          if(alertsSound)   PlaySound("alert2.wav");
   }
}